% -----------------------------------------------------------------------------
% Create custom mathematical commands
% -----------------------------------------------------------------------------

% Define distance between matrix rows
\renewcommand*{\arraystretch}{1.25}

% Define width of equal sign
\newlength{\equalsignwidth}
\setlength{\equalsignwidth}{\widthof{$=$}}

% Define custom equal sign in math mode with spaces
\newcommand{\meq}{\; &= \;}
\newcommand{\meqskip}{\; &\hspace{\equalsignwidth} \;}
\newcommand{\meqna}{\; = \;}
\newcommand{\mapprox}{\; &\approx \;}
\newcommand{\mleq}{\; &\leq \;}
\newcommand{\mgeq}{\; &\geq \;}
\newcommand{\mdef}{\; &\coloneqq \;}

% Define double tilde command
%\usepackage{accents}
%\newcommand{\dbtilde}[1]{\accentset{\approx}{#1}}
\newcommand{\dtilde}[1]{\tilde{\raisebox{-0.5pt}[0.85\height]{$\tilde{#1}$}}}

% Custom size overline/bar above symbols
\newcommand{\xbar}[2][3]{%
{}\mkern#1mu\overline{\mkern-#1mu#2}}

% Brackets
\newcommand{\braRound}[1]{\ensuremath{\left(#1\right)}}
\newcommand{\braSquare}[1]{\ensuremath{\left[#1\right]}}
\newcommand{\braCurl}[1]{\ensuremath{\left\lbrace#1\right\rbrace}}
\newcommand{\braAngle}[1]{\ensuremath{\left\langle#1\right\rangle}}
\newcommand{\braNorm}[1]{\ensuremath{\left\lVert#1\right\rVert}}

% Differential
\newcommand{\diff}{\textrm{d}}

% Derivative
\newcommand{\derivative}[2]{\ensuremath{\frac{\diff#1}{\diff#2}}}
\newcommand{\pderivative}[2]{\ensuremath{\frac{\partial#1}{\partial#2}}}

% Transposition
\newcommand{\transpose}{\ensuremath{^{\textrm{T}}}}
\newcommand{\itranspose}{\ensuremath{^{-\textrm{T}}}}

% Unit step
\newcommand{\unitstep}{\ensuremath{\mathds{1}}}

% Controllability matrix
\newcommand{\cntmat}{\ensuremath{\mathcal{C}}}

% Observability matrix
\newcommand{\obsmat}{\ensuremath{\mathcal{O}}}

% Range of map
\newcommand{\Range}{\textrm{Range}}

% Span of map
\newcommand{\Span}{\textrm{Span}}

% Rank of matrix
\newcommand{\rank}[1]{\textrm{rank}}

% Eigenvalue
\newcommand{\eig}[1]{\textrm{eig}}

% Arg max
\newcommand{\argmax}[1]{\ensuremath{\textrm{arg}\ \max\limits_{#1}}}

% Algebraic multiplicity
\newcommand{\algmult}{\ensuremath{\textrm{n}_{\textrm{a}}}}

% Geometrical multiplicity
\newcommand{\geomult}{\ensuremath{\textrm{n}_{\textrm{g}}}}

% Set of natural numbers
\newcommand{\numsetN}{\ensuremath{\mathbb{N}}}

% Set of integer numbers
\newcommand{\numsetZ}{\ensuremath{\mathbb{Z}}}

% Set of real numbers
\newcommand{\numsetR}{\ensuremath{\mathbb{R}}}

% Set of complex numbers
\newcommand{\numsetC}{\ensuremath{\mathbb{C}}}
